report 72103 SalesCreditMemoDCR
{
    Caption = 'Sales - Credit Memo';
    Permissions = TableData "Sales Shipment Buffer" = rimd;
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(InvHdr; "Sales Cr.Memo Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.", "Sell-to Customer No.", "No. Printed";
            RequestFilterHeading = 'Posted Sales Credit Memo';

            column(lblAllowInvDisc; Trl('AllowInvDisc')) { }
            column(lblAmount; Trl('Amount')) { }
            column(lblAmountInclVAT; Trl('AmountInclVAT')) { }
            column(lblAttachedToLineNo; Trl('AttachedToLineNo')) { }
            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblBillToAddress; Trl('BillToAddress')) { }
            column(lblBillToCustomerNo; Trl('BillToCustomerNo')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblCreditMemoNo; Trl('CreditMemoNo')) { }
            column(lblCrossReferenceNo; Trl('CrossReferenceNo')) { }
            column(lblDescription; Trl('Description')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDocumentNo; Trl('DocumentNo')) { }
            column(lblDueDate; Trl('DueDate')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblExternalDocumentNo; Trl('ExternalDocumentNo')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblGiroNo; Trl('GiroNo')) { }
            column(lblGLAccountNo; Trl('GLAccountNo')) { }
            column(lblGrossWeight; Trl('GrossWeight')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblInvDiscAmount; Trl('InvDiscAmount')) { }
            column(lblInvDiscBaseAmount; Trl('InvDiscBaseAmount')) { }
            column(lblInvoiceDate; Trl('InvoiceDate')) { }
            column(lblLineAmount; Trl('LineAmount')) { }
            column(lblLineDimensions; Trl('LineDimensions')) { }
            column(lblLineDiscountAmount; Trl('LineDiscountAmount')) { }
            column(lblLineDiscountPerc; Trl('LineDiscountPerc')) { }
            column(lblLineNo; Trl('LineNo')) { }
            column(lblLocationCode; Trl('LocationCode')) { }
            column(lblLotNo; Trl('LotNo')) { }
            column(lblNetWeight; Trl('NetWeight')) { }
            column(lblNo; Trl('No')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPaymentDiscountVAT; Trl('PaymentDiscountVAT')) { }
            column(lblPaymentMethod; Trl('PaymentMethod')) { }
            column(lblPaymentTerms; Trl('PaymentTerms')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblPrepaymentPaymentTerms; Trl('PrepaymentPaymentTerms')) { }
            column(lblPrepaymentSpecification; Trl('PrepaymentSpecification')) { }
            column(lblPrepaymentVATSpecification; Trl('PrepaymentVATSpecification')) { }
            column(lblPricesInclVAT; Trl('PricesInclVAT')) { }
            column(lblQuantity; Trl('Quantity')) { }
            column(lblReturnOrderNo; Trl('ReturnOrderNo')) { }
            column(lblReturnReceipt; Trl('ReturnReceipt')) { }
            column(lblQuantityBase; Trl('QuantityBase')) { }
            column(lblQtyPerUOM; Trl('QtyPerUOM')) { }
            column(lblReturnReceiptDate; Trl('ReturnReceiptDate')) { }
            column(lblSalesPerson; Trl('SalesPerson')) { }
            column(lblSellToCustomerNo; Trl('SellToCustomerNo')) { }
            column(lblSerialNo; Trl('SerialNo')) { }
            column(lblShipmentMethod; Trl('ShipmentMethod')) { }
            column(lblShipToAddress; Trl('ShipToAddress')) { }
            column(lblSubtotal; Trl('Subtotal')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblType; Trl('Type')) { }
            column(lblUnitCost; Trl('UnitCost')) { }
            column(lblUnitCostLCY; Trl('UnitCostLCY')) { }
            column(lblUnitsPerParcel; Trl('UnitsPerParcel')) { }
            column(lblUnitPrice; Trl('UnitPrice')) { }
            column(lblUOM; Trl('UOM')) { }
            column(lblUOMCode; Trl('UOMCode')) { }
            column(lblVATAmount; Trl('VATAmount')) { }
            column(lblVATAmountSpecification; Trl('VATAmountSpecification')) { }
            column(lblVATBase; Trl('VATBase')) { }
            column(lblVATClause; Trl('VATClause')) { }
            column(lblVATIdentifier; Trl('VATIdentifier')) { }
            column(lblVATPerc; Trl('VATPerc')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblYourReference; Trl('YourReference')) { }

            column(BilltoCustNo; "Bill-to Customer No.") { }
            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(CustAddr1; wgCustAddr[1]) { }
            column(CustAddr2; wgCustAddr[2]) { }
            column(CustAddr3; wgCustAddr[3]) { }
            column(CustAddr4; wgCustAddr[4]) { }
            column(CustAddr5; wgCustAddr[5]) { }
            column(CustAddr6; wgCustAddr[6]) { }
            column(CustAddr7; wgCustAddr[7]) { }
            column(CustAddr8; wgCustAddr[8]) { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, 4)) { }
            column(DocumentNo; "No.") { }
            column(DueDate; "Due Date") { }
            column(DueDateText; Format("Due Date", 0, 4)) { }
            column(ExternalDocumentNo; "External Document No.") { }
            column(HideLineDiscount; wgHideLineDiscount) { }
            column(LanguageCode; "Language Code") { }
            column(LocationCity; wgRecLocation.City) { }
            column(LocationCode; "Location Code") { }
            column(LocationName; wgRecLocation.Name) { }
            column(PaymentMethodDesc; wgRecPaymentMethod.Description) { }
            column(PaymentTermsDesc; wgRecPaymentTerms.Description) { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, 4)) { }
            column(PrepaymentCreditMemo; "Prepayment Credit Memo") { }
            column(PrepaymentOrderNo; "Prepayment Order No.") { }
            column(PricesInclVAT; "Prices Including VAT") { }
            column(PricesInclVATYesNo; Format("Prices Including VAT")) { }
            column(ReturnOrderNo; "Return Order No.") { }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name) { }
            column(SelltoCustNo; "Sell-to Customer No.") { }
            column(SelltoPhoneNo; "Sell-to Phone No.") { }
            column(ShipmentMethodDesc; wgRecShipmentMethod.Description) { }
            column(ShipToAddr1; wgShipToAddr[1]) { }
            column(ShipToAddr2; wgShipToAddr[2]) { }
            column(ShipToAddr3; wgShipToAddr[3]) { }
            column(ShipToAddr4; wgShipToAddr[4]) { }
            column(ShipToAddr5; wgShipToAddr[5]) { }
            column(ShipToAddr6; wgShipToAddr[6]) { }
            column(ShipToAddr7; wgShipToAddr[7]) { }
            column(ShipToAddr8; wgShipToAddr[8]) { }
            column(ShipToAddrSet; wgShowShippingAddr) { }
            column(TodayText; Format(Today(), 0, 4)) { }
            column(TotalText; wgTotalText) { }
            column(TotalExclVATText; wgTotalExclVATText) { }
            column(TotalInclVATText; wgTotalInclVATText) { }
            column(VALExchRate; wgVALExchRate) { }
            column(VALSpecLCYHeader; wgVALSpecLCYHeader) { }
            column(VATBaseDiscPerc; "VAT Base Discount %")
            {
                AutoFormatType = 1;
            }
            column(VATBusPostingGroup; "VAT Bus. Posting Group") { }
            column(VATRegNo; "VAT Registration No.") { }
            column(YourReference; "Your Reference") { }

            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);

                column(OutputNo; wgOutputNo) { }
                column(SalesCrMemoTitle; StrSubstNo(wlFncDocumentCaption(), wgCopyText)) { }

                dataitem(HdrComment; "Sales Comment Line")
                {
                    DataItemLink = "No." = Field("No.");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Credit Memo"), "Document Line No." = const(0));

                    column(Comment_2; Comment) { }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                    DataItemLinkReference = InvHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                    column(DimText; wgDimText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(InvLine; "Sales Cr.Memo Line")
                {
                    DataItemTableView = sorting("Document No.", "Line No.");
                    UseTemporary = true;

                    column(Amount; Amount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AmountInclVAT; "Amount Including VAT")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(AttachedToLineNo; "Attached to Line No.") { }
                    column(CrossReferenceNo; "Cross-Reference No.") { }
                    column(Description; Description) { }
                    column(Description2_2; "Description 2") { }
                    column(GrossWeight; "Gross Weight") { }
                    column(InvDiscAmount; -"Inv. Discount Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount; "Line Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineDiscAmount; "Line Discount Amount") { }
                    column(LineDiscPerc; "Line Discount %") { }
                    column(LineNo; "Line No.") { }
                    column(NetWeight; "Net Weight") { }
                    column(No_2; "No.") { }
                    column(PostedReceiptDate; wgPostedShipmentDate) { }
                    column(QtyPerUOM; "Qty. per Unit of Measure") { }
                    column(Quantity; Quantity) { }
                    column(QuantityBase; "Quantity (Base)") { }
                    column(Type; Format(Type)) { }
                    column(TypeNo; Type + 0) { }
                    column(UnitCost; "Unit Cost") { }
                    column(UnitCostLCY; "Unit Cost (LCY)") { }
                    column(UnitPrice; "Unit Price")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 2;
                    }
                    column(UnitsPerParcel; "Units per Parcel") { }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }
                    column(UOMCode; "Unit of Measure Code") { }
                    column(VATIdentifier; "VAT Identifier") { }

                    dataitem(LineComment; "Sales Comment Line")
                    {
                        DataItemLink = "No." = Field("Document No."), "Document Line No." = Field("Line No.");
                        DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Credit Memo"));

                        column(Comment; Comment) { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(ShipmentBuf; "Sales Shipment Buffer")
                    {
                        DataItemTableView = sorting("Document No.", "Line No.", "Entry No.");
                        UseTemporary = true;

                        column(Quantity_5; Quantity) { }
                        column(PostingDate_2; "Posting Date") { }

                        trigger OnPreDataItem()
                        begin
                            Reset();
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                        column(DimText_2; wgDimText) { }

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(TrackingSpec; "Tracking Specification")
                    {
                        DataItemTableView = sorting("Entry No.");
                        UseTemporary = true;

                        column(LotNo; "Lot No.") { }
                        column(SerialNo; "Serial No.") { }
                        column(Quantity_4; "Quantity (Base)") { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowLotSN then
                                CurrReport.Break();

                            Reset();
                            SetRange("Source Ref. No.", InvLine."Line No.");
                        end;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        //Get Shipment Lines
                        wgPostedShipmentDate := 0D;
                        if InvLine.Quantity <> 0 then
                            wgPostedShipmentDate := wlFncFindPostedShipmentDate(InvLine);

                        if not InvHdr."Prices Including VAT" and
                           (InvLine."VAT Calculation Type" = InvLine."VAT Calculation Type"::"Full VAT")
                        then
                            InvLine."Line Amount" := 0;

                        if (InvLine.Type = InvLine.Type::"G/L Account") and (not wgShowInternalInfo) then
                            InvLine."No." := '';
                    end;

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        Reset();
                        wlMoreLines := InvLine.Find('+');
                        while wlMoreLines and (InvLine.Description = '') and (InvLine."Description 2" = '') and
                              (InvLine."No." = '') and (InvLine.Quantity = 0) and
                              (InvLine.Amount = 0)
                        do
                            wlMoreLines := InvLine.Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        InvLine.SetRange("Line No.", 0, InvLine."Line No.");
                    end;
                }
                dataitem(VATAmtLine; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(InvDiscAmount_2; "Invoice Discount Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(InvDiscBaseAmount; "Inv. Disc. Base Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(LineAmount_2; "Line Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmount; "VAT Amount")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATBase; "VAT Base")
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_2; "VAT Identifier") { }
                    column(VATPerc; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnPreDataItem()
                    begin
                        if wgTotVATAmount = 0 then
                            CurrReport.Break();

                        Reset();
                    end;
                }
                dataitem(VATClause; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(Description_4; wgRecVATClause.Description) { }
                    column(Description2; wgRecVATClause."Description 2") { }
                    column(VATAmount_4; "VAT Amount") { }
                    column(VATClauseCode; "VAT Clause Code") { }
                    column(VATIdentifier_4; "VAT Identifier") { }

                    trigger OnAfterGetRecord()
                    begin
                        if "VAT Clause Code" = '' then
                            CurrReport.Skip();
                        if wgRecVATClause.Code <> "VAT Clause Code" then
                            if not wgRecVATClause.Get("VAT Clause Code") then
                                CurrReport.Skip();

                        wgRecVATClause.TranslateDescription(InvHdr."Language Code");
                    end;

                    trigger OnPreDataItem()
                    begin
                        Copy(VATAmtLine, true); //Set VATClause to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(VATAmtLineLCY; "VAT Amount Line")
                {
                    DataItemTableView = sorting("VAT Identifier", "VAT Calculation Type", "Tax Group Code", "Use Tax", Positive);
                    UseTemporary = true;

                    column(VALVATBaseLCY; wgVALVATBaseLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VALVATAmountLCY; wgVALVATAmountLCY)
                    {
                        AutoFormatType = 1;
                    }
                    column(VATIdentifier_3; "VAT Identifier") { }
                    column(VATPerc_2; "VAT %")
                    {
                        DecimalPlaces = 0 : 5;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        wgVALVATBaseLCY :=
                          VATAmtLine.GetBaseLCY(
                            InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");
                        wgVALVATAmountLCY :=
                          VATAmtLine.GetAmountLCY(
                            InvHdr."Posting Date", InvHdr."Currency Code", InvHdr."Currency Factor");

                        wgTotVALVATBaseLCY += wgVALVATBaseLCY;
                        wgTotVALVATAmountLCY += wgVALVATAmountLCY;
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowVATLCY then
                            CurrReport.Break();

                        Copy(VATAmtLine, true); //Set VATAmtLineLCY to VATAmtLine
                        Reset();
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));

                    column(MonolithicVAT; wgMonolithicVAT) { }
                    column(NoOfVATAmtLines; wgNoOfVATAmountLines) { }
                    column(TotAmount; wgTotAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotInvDiscAmount; wgTotInvDiscAmount) { }
                    column(TotInvDiscBaseAmount; wgTotInvDiscBaseAmount) { }
                    column(TotLineAmount; wgTotLineAmount) { }
                    column(TotPaymentDiscOnVAT; wgTotPaymentDiscOnVAT)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(TotVATAmount; wgTotVATAmount)
                    {
                        AutoFormatExpression = InvHdr."Currency Code";
                        AutoFormatType = 1;
                    }
                    column(VATAmtText; wgVATAmountText) { }
                    column(TotVALVATBaseLCY; wgTotVALVATBaseLCY) { }
                    column(TotVALVATAmountLCY; wgTotVALVATAmountLCY) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgNoOfVATAmountLines := VATAmtLine.Count();
                        wgMonolithicVAT := wgCduwDCR_ReportFunctions.wgFncIsMonolithicVAT(VATAmtLine);
                        if wgMonolithicVAT then
                            wgVATAmountText := CopyStr(StrSubstNo(Trl('TotalVATAmount%1Perc'), VATAmtLine."VAT %"), 1, 30)
                        else
                            wgVATAmountText := CopyStr(Trl('TotalVATAmount'), 1, 30);
                    end;
                }

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, 30);
                        wgOutputNo += 1;
                    end;

                    wgTotVALVATBaseLCY := 0;
                    wgTotVALVATAmountLCY := 0;
                end;

                trigger OnPostDataItem()
                begin
                    if not CurrReport.Preview() then
                        Codeunit.Run(Codeunit::"Sales Cr. Memo-Printed", InvHdr);
                end;

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;
            }

            trigger OnAfterGetRecord()
            var
                wlRecRef: RecordRef;
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatAddressFields(InvHdr);
                wlFncFormatDocumentFields(InvHdr);

                if wgLogInteraction then
                    if not CurrReport.Preview() then
                        if "Bill-to Contact No." <> '' then
                            wgCduSegManagement.LogDocument(
                              6, "No.", 0, 0, Database::Contact, "Bill-to Contact No.", "Salesperson Code",
                              "Campaign No.", "Posting Description", '')
                        else
                            wgCduSegManagement.LogDocument(
                              6, "No.", 0, 0, Database::Customer, "Bill-to Customer No.", "Salesperson Code",
                              "Campaign No.", "Posting Description", '');

                //Get Credit Memo Lines
                InvLine.Reset();
                InvLine.DeleteAll();
                VATAmtLine.Reset();
                VATAmtLine.DeleteAll();
                wlFncGetSalesCrMemoLines(InvHdr, InvLine);

                //Get VAT Amount Lines
                InvLine.CalcVATAmountLines(InvHdr, VATAmtLine);
                wgTotInvDiscAmount := VATAmtLine.GetTotalInvDiscAmount();
                wgTotInvDiscBaseAmount := VATAmtLine.GetTotalInvDiscBaseAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotLineAmount := VATAmtLine.GetTotalLineAmount(InvHdr."Prices Including VAT", InvHdr."Currency Code");
                wgTotVATAmount := VATAmtLine.GetTotalVATAmount();
                wgTotPaymentDiscOnVAT := -(wgTotLineAmount - wgTotInvDiscAmount - VATAmtLine.GetTotalAmountInclVAT());
                wgTotAmount := VATAmtLine.GetTotalVATBase();

                //Prepare VAT Amount Lines LCY
                if (not wgRecGLSetup."Print VAT specification in LCY") or
                   (InvHdr."Currency Code" = '') or
                   (VATAmtLine.GetTotalVATAmount() = 0)
                then begin
                    wgShowVATLCY := false;
                    wgVALSpecLCYHeader := '';
                    wgVALExchRate := '';
                end
                else begin
                    wgShowVATLCY := true;
                    if wgRecGLSetup."LCY Code" = '' then
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Trl('LocalCurrency')
                    else
                        wgVALSpecLCYHeader := Trl('VATAmtSpecIn') + ' ' + Format(wgRecGLSetup."LCY Code");
                    wgRecCurrExchRate.FindCurrency(InvHdr."Posting Date", InvHdr."Currency Code", 1);
                    wgVALExchRate := CopyStr(StrSubstNo(Trl('ExchangeRate%1/%2'), wgRecCurrExchRate."Relational Exch. Rate Amount", wgRecCurrExchRate."Exchange Rate Amount"), 1, 50);
                end;

                //Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();

                if wgShowLotSN then
                    wlFncRetrieveDocumentItemTracking(TrackingSpec, InvHdr."No.", Database::"Sales Cr.Memo Header", 0);

                //Set HideLineDiscount
                wlRecRef.GetTable(InvHdr);
                wgHideLineDiscount := wgCduwDCR_ReportFunctions.wgFncHideLineDiscount(wlRecRef);

                if not wgRecLocation.Get("Location Code") then
                    Clear(wgRecLocation);
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            InitLogInteraction();
            wgLogInteractionEnable := wgLogInteraction;

            wgNoOfCopies := 0;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecGLSetup.Get();

        wgRecSalesSetup.Get();

        wgRecCompanyInfo.Get();

        if wgRecSalesSetup."Logo Position on Documents" <> wgRecSalesSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    trigger OnPreReport()
    begin
        if not CurrReport.UseRequestPage() then begin
            wgNoOfCopies := 0;
            InitLogInteraction();
        end;
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecCurrExchRate: Record "Currency Exchange Rate";
        wgRecGLSetup: Record "General Ledger Setup";
        wgRecLocation: Record Location;
        wgRecPaymentMethod: Record "Payment Method";
        wgRecPaymentTerms: Record "Payment Terms";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecSalesSetup: Record "Sales & Receivables Setup";
        wgRecShipmentMethod: Record "Shipment Method";
        wgRecVATClause: Record "VAT Clause";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduFormatDoc: Codeunit "Format Document";
        wgCduLanguage: Codeunit Language;
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgPostedShipmentDate: Date;
        wgCompanyAddr: array[8] of Text[100];
        wgCompanyInfoFaxNo: Text;
        wgCompanyInfoPhoneNo: Text;
        wgCopyText: Text[30];
        wgCustAddr: array[8] of Text[100];
        wgDimText: Text[120];
        wgShipToAddr: array[8] of Text[100];
        wgTotalExclVATText: Text[50];
        wgTotalInclVATText: Text[50];
        wgTotalText: Text[50];
        wgVALExchRate: Text[50];
        wgVALSpecLCYHeader: Text[80];
        wgVATAmountText: Text[30];
        wgTotAmount: Decimal;
        wgTotInvDiscAmount: Decimal;
        wgTotInvDiscBaseAmount: Decimal;
        wgTotLineAmount: Decimal;
        wgTotPaymentDiscOnVAT: Decimal;
        wgTotVALVATAmountLCY: Decimal;
        wgTotVALVATBaseLCY: Decimal;
        wgTotVATAmount: Decimal;
        wgVALVATAmountLCY: Decimal;
        wgVALVATBaseLCY: Decimal;
        wgFirstValueEntryNo: Integer;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgNoOfVATAmountLines: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgShipmentLineNextEntryNo: Integer;
        wgHideLineDiscount: Boolean;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgMonolithicVAT: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;
        wgShowShippingAddr: Boolean;
        wgShowVATLCY: Boolean;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        if wgReportId = 0 then begin
            Evaluate(wgReportId, DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890')));
            wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        end;
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    procedure InitializeRequest(pNewNoOfCopies: Integer; pNewShowInternalInfo: Boolean; pNewLogInteraction: Boolean)
    begin
        wgNoOfCopies := pNewNoOfCopies;
        wgShowInternalInfo := pNewShowInternalInfo;
        wgLogInteraction := pNewLogInteraction;
    end;

    procedure InitLogInteraction()
    begin
        wgLogInteraction := wgCduSegManagement.FindInteractTmplCode(6) <> '';
    end;

    local procedure wlFncDocumentCaption(): Text[250]
    begin
        if InvHdr."Prepayment Credit Memo" then
            exit(CopyStr(Trl('SalesPrepaymentCreditMemo%1'), 1, 250));
        exit(CopyStr(Trl('SalesCreditMemo%1'), 1, 250));
    end;

    local procedure wlFncGetSalesCrMemoLines(var vRecSalesCrMemoHeader: Record "Sales Cr.Memo Header"; var vRecSalesCrMemoLine: Record "Sales Cr.Memo Line")
    var
        wlRecSalesCrMemoLine: Record "Sales Cr.Memo Line";
    begin
        wlRecSalesCrMemoLine.SetRange("Document No.", vRecSalesCrMemoHeader."No.");
        if wlRecSalesCrMemoLine.FindSet() then
            repeat
                vRecSalesCrMemoLine := wlRecSalesCrMemoLine;
                vRecSalesCrMemoLine.Insert();
            until wlRecSalesCrMemoLine.Next() = 0;
    end;

    local procedure wlFncFindPostedShipmentDate(var vRecSalesCrMemoLine: Record "Sales Cr.Memo Line"): Date
    var
        wlRecReturnReceiptHeader: Record "Return Receipt Header";
        wlRecSalesShipmentBuffer2: Record "Sales Shipment Buffer" temporary;
    begin
        //According FindPostedShipmentDate Report 207
        wgShipmentLineNextEntryNo := 1;
        if vRecSalesCrMemoLine."Return Receipt No." <> '' then
            if wlRecReturnReceiptHeader.Get(vRecSalesCrMemoLine."Return Receipt No.") then
                exit(wlRecReturnReceiptHeader."Posting Date");

        if InvHdr."Return Order No." = '' then
            exit(InvHdr."Posting Date");

        case vRecSalesCrMemoLine.Type of
            vRecSalesCrMemoLine.Type::Item:
                wlFncGenerateBufferFromValueEntry(vRecSalesCrMemoLine);
            vRecSalesCrMemoLine.Type::"G/L Account", vRecSalesCrMemoLine.Type::Resource,
          vRecSalesCrMemoLine.Type::"Charge (Item)", vRecSalesCrMemoLine.Type::"Fixed Asset":
                wlFncGenerateBufferFromShipment(vRecSalesCrMemoLine);
            vRecSalesCrMemoLine.Type::" ":
                exit(0D);
        end;

        ShipmentBuf.Reset();
        ShipmentBuf.SetRange("Document No.", vRecSalesCrMemoLine."Document No.");
        ShipmentBuf.SetRange("Line No.", vRecSalesCrMemoLine."Line No.");
        if ShipmentBuf.Find('-') then begin
            wlRecSalesShipmentBuffer2 := ShipmentBuf;
            if ShipmentBuf.Next() = 0 then begin
                ShipmentBuf.Get(
                  wlRecSalesShipmentBuffer2."Document No.", wlRecSalesShipmentBuffer2."Line No.", wlRecSalesShipmentBuffer2."Entry No.");
                ShipmentBuf.Delete();
                exit(wlRecSalesShipmentBuffer2."Posting Date");
            end;
            ShipmentBuf.CalcSums(Quantity);
            if ShipmentBuf.Quantity <> vRecSalesCrMemoLine.Quantity then begin
                ShipmentBuf.DeleteAll();
                exit(InvHdr."Posting Date");
            end;
        end else
            exit(InvHdr."Posting Date");
    end;

    local procedure wlFncGenerateBufferFromValueEntry(var vRecSalesCrMemoLine: Record "Sales Cr.Memo Line")
    var
        wlRecItemLedgerEntry: Record "Item Ledger Entry";
        wlRecValueEntry: Record "Value Entry";
        wlQuantity: Decimal;
        wlTotalQuantity: Decimal;
    begin
        //According GenerateBufferFromValueEntry Report 207
        wlTotalQuantity := vRecSalesCrMemoLine."Quantity (Base)";
        wlRecValueEntry.SetCurrentKey("Document No.");
        wlRecValueEntry.SetRange("Document No.", vRecSalesCrMemoLine."Document No.");
        wlRecValueEntry.SetRange("Posting Date", InvHdr."Posting Date");
        wlRecValueEntry.SetRange("Item Charge No.", '');
        wlRecValueEntry.SetFilter("Entry No.", '%1..', wgFirstValueEntryNo);
        if wlRecValueEntry.Find('-') then
            repeat
                if wlRecItemLedgerEntry.Get(wlRecValueEntry."Item Ledger Entry No.") then begin
                    if vRecSalesCrMemoLine."Qty. per Unit of Measure" <> 0 then
                        wlQuantity := wlRecValueEntry."Invoiced Quantity" / vRecSalesCrMemoLine."Qty. per Unit of Measure"
                    else
                        wlQuantity := wlRecValueEntry."Invoiced Quantity";
                    wlFncAddBufferEntry(
                      vRecSalesCrMemoLine,
                      -wlQuantity,
                      wlRecItemLedgerEntry."Posting Date");
                    wlTotalQuantity += wlRecValueEntry."Invoiced Quantity";
                end;
                wgFirstValueEntryNo := wlRecValueEntry."Entry No." + 1;
            until (wlRecValueEntry.Next() = 0) or (wlTotalQuantity = 0);
    end;

    local procedure wlFncGenerateBufferFromShipment(pRecSalesCrMemoLine: Record "Sales Cr.Memo Line")
    var
        wlRecSalesCrMemoHeader: Record "Sales Cr.Memo Header";
        wlRecSalesCrMemoLine2: Record "Sales Cr.Memo Line";
        wlRecReturnReceiptHeader: Record "Return Receipt Header";
        wlRecReturnReceiptLine: Record "Return Receipt Line";
        wlQuantity: Decimal;
        wlTotalQuantity: Decimal;
    begin
        //According GenerateBufferFromShipment Report 207
        wlTotalQuantity := 0;
        wlRecSalesCrMemoHeader.SetCurrentKey("Return Order No.");
        wlRecSalesCrMemoHeader.SetFilter("No.", '..%1', InvHdr."No.");
        wlRecSalesCrMemoHeader.SetRange("Return Order No.", InvHdr."Return Order No.");
        if wlRecSalesCrMemoHeader.Find('-') then
            repeat
                wlRecSalesCrMemoLine2.SetRange("Document No.", wlRecSalesCrMemoHeader."No.");
                wlRecSalesCrMemoLine2.SetRange("Line No.", pRecSalesCrMemoLine."Line No.");
                wlRecSalesCrMemoLine2.SetRange(Type, pRecSalesCrMemoLine.Type);
                wlRecSalesCrMemoLine2.SetRange("No.", pRecSalesCrMemoLine."No.");
                wlRecSalesCrMemoLine2.SetRange("Unit of Measure Code", pRecSalesCrMemoLine."Unit of Measure Code");
                if wlRecSalesCrMemoLine2.Find('-') then
                    repeat
                        wlTotalQuantity := wlTotalQuantity + wlRecSalesCrMemoLine2.Quantity;
                    until wlRecSalesCrMemoLine2.Next() = 0;
            until wlRecSalesCrMemoHeader.Next() = 0;

        wlRecReturnReceiptLine.SetCurrentKey("Return Order No.", "Return Order Line No.");
        wlRecReturnReceiptLine.SetRange("Return Order No.", InvHdr."Return Order No.");
        wlRecReturnReceiptLine.SetRange("Return Order Line No.", pRecSalesCrMemoLine."Line No.");
        wlRecReturnReceiptLine.SetRange("Line No.", pRecSalesCrMemoLine."Line No.");
        wlRecReturnReceiptLine.SetRange(Type, pRecSalesCrMemoLine.Type);
        wlRecReturnReceiptLine.SetRange("No.", pRecSalesCrMemoLine."No.");
        wlRecReturnReceiptLine.SetRange("Unit of Measure Code", pRecSalesCrMemoLine."Unit of Measure Code");
        wlRecReturnReceiptLine.SetFilter(Quantity, '<>%1', 0);

        if wlRecReturnReceiptLine.Find('-') then
            repeat
                if InvHdr."Get Return Receipt Used" then
                    wlFncCorrectShipment(wlRecReturnReceiptLine);
                if Abs(wlRecReturnReceiptLine.Quantity) <= Abs(wlTotalQuantity - pRecSalesCrMemoLine.Quantity) then
                    wlTotalQuantity := wlTotalQuantity - wlRecReturnReceiptLine.Quantity
                else begin
                    if Abs(wlRecReturnReceiptLine.Quantity) > Abs(wlTotalQuantity) then
                        wlRecReturnReceiptLine.Quantity := wlTotalQuantity;
                    wlQuantity :=
                      wlRecReturnReceiptLine.Quantity - (wlTotalQuantity - pRecSalesCrMemoLine.Quantity);

                    wlTotalQuantity := wlTotalQuantity - wlRecReturnReceiptLine.Quantity;
                    pRecSalesCrMemoLine.Quantity := pRecSalesCrMemoLine.Quantity - wlQuantity;

                    if wlRecReturnReceiptHeader.Get(wlRecReturnReceiptLine."Document No.") then
                        wlFncAddBufferEntry(
                          pRecSalesCrMemoLine,
                          wlQuantity,
                          wlRecReturnReceiptHeader."Posting Date");
                end;
            until (wlRecReturnReceiptLine.Next() = 0) or (wlTotalQuantity = 0);
    end;

    local procedure wlFncCorrectShipment(var vRecReturnReceiptLine: Record "Return Receipt Line")
    var
        wlRecSalesCrMemoLine: Record "Sales Cr.Memo Line";
    begin
        //According CorrectShipment Report 207
        wlRecSalesCrMemoLine.SetCurrentKey("Return Receipt No.", "Return Receipt Line No.");
        wlRecSalesCrMemoLine.SetRange("Return Receipt No.", vRecReturnReceiptLine."Document No.");
        wlRecSalesCrMemoLine.SetRange("Return Receipt Line No.", vRecReturnReceiptLine."Line No.");
        if wlRecSalesCrMemoLine.Find('-') then
            repeat
                vRecReturnReceiptLine.Quantity := vRecReturnReceiptLine.Quantity - wlRecSalesCrMemoLine.Quantity;
            until wlRecSalesCrMemoLine.Next() = 0;
    end;

    procedure wlFncAddBufferEntry(var vRecSalesCrMemoLine: Record "Sales Cr.Memo Line"; pQtyOnShipment: Decimal; pPostingDate: Date)
    begin
        //According AddBufferEntry Report 207
        ShipmentBuf.SetRange("Document No.", vRecSalesCrMemoLine."Document No.");
        ShipmentBuf.SetRange("Line No.", vRecSalesCrMemoLine."Line No.");
        ShipmentBuf.SetRange("Posting Date", pPostingDate);
        if ShipmentBuf.Find('-') then begin
            ShipmentBuf.Quantity := ShipmentBuf.Quantity + pQtyOnShipment;
            ShipmentBuf.Modify();
            exit;
        end;

        with ShipmentBuf do begin
            "Document No." := vRecSalesCrMemoLine."Document No.";
            "Line No." := vRecSalesCrMemoLine."Line No.";
            "Entry No." := wgShipmentLineNextEntryNo;
            Type := vRecSalesCrMemoLine.Type;
            "No." := vRecSalesCrMemoLine."No.";
            Quantity := pQtyOnShipment;
            "Posting Date" := pPostingDate;
            Insert();
            wgShipmentLineNextEntryNo += 1;
        end;
    end;

    local procedure wlFncRetrieveDocumentItemTracking(var vRecTrackingSpecBuffer: Record "Tracking Specification" temporary; pSourceID: Code[20]; pSourceType: Integer; pSourceSubType: Option): Integer
    begin
        vRecTrackingSpecBuffer.DeleteAll();
        vRecTrackingSpecBuffer.Reset();
        exit(vRecTrackingSpecBuffer.Count());
    end;

    local procedure wlFncFormatDocumentFields(pRecSalesCrMemoHeader: Record "Sales Cr.Memo Header")
    var
        wlSalesPersonText: Text[50];
        wlCurrencyCode: Code[10];
    begin
        with pRecSalesCrMemoHeader do begin
            wlCurrencyCode := "Currency Code";
            if wlCurrencyCode = '' then begin
                wgRecGLSetup.TestField("LCY Code");
                wlCurrencyCode := wgRecGLSetup."LCY Code";
            end;
            wgTotalText := CopyStr(StrSubstNo(Trl('Total%1'), wlCurrencyCode), 1, 50);
            wgTotalInclVATText := CopyStr(StrSubstNo(Trl('Total%1InclVAT'), wlCurrencyCode), 1, 50);
            wgTotalExclVATText := CopyStr(StrSubstNo(Trl('Total%1ExclVAT'), wlCurrencyCode), 1, 50);
            wgCduFormatDoc.SetSalesPerson(wgRecSalesPurchPerson, "Salesperson Code", wlSalesPersonText);
            wgCduFormatDoc.SetPaymentTerms(wgRecPaymentTerms, "Payment Terms Code", "Language Code");
            wgCduFormatDoc.SetPaymentMethod(wgRecPaymentMethod, "Payment Method Code", "Language Code");
            wgCduFormatDoc.SetShipmentMethod(wgRecShipmentMethod, "Shipment Method Code", "Language Code");
        end;
    end;

    local procedure wlFncFormatAddressFields(var vRecSalesCrMemoHeader: Record "Sales Cr.Memo Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
    begin
        wgCduFormatAddr.GetCompanyAddr(vRecSalesCrMemoHeader."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";
        wgCduFormatAddr.SalesCrMemoBillTo(wgCustAddr, vRecSalesCrMemoHeader);
        wgShowShippingAddr := wgCduFormatAddr.SalesCrMemoShipTo(wgShipToAddr, wgCustAddr, vRecSalesCrMemoHeader);
    end;
}
