report 72141 PurchaseRetShipmtDCR
{
    Caption = 'Purchase - Return Shipment';
    PreviewMode = PrintLayout;
    UsageCategory = None;

    dataset
    {
        dataitem(ShptHdr; "Return Shipment Header")
        {
            DataItemTableView = sorting("No.");
            RequestFilterFields = "No.", "Buy-from Vendor No.", "No. Printed";
            RequestFilterHeading = 'Posted Return Shipment';

            column(lblBankAccNo; Trl('BankAccNo')) { }
            column(lblBankBranchNo; Trl('BankBranchNo')) { }
            column(lblBankName; Trl('BankName')) { }
            column(lblCompanyRegistrationNo; Trl('CompanyRegistrationNo')) { }
            column(lblDescription; Trl('Description')) { }
            column(lblDocumentDate; Trl('DocumentDate')) { }
            column(lblDueDate; Trl('DueDate')) { }
            column(lblEmail; Trl('Email')) { }
            column(lblFaxNo; Trl('FaxNo')) { }
            column(lblFreeText1; Trl('FreeText1')) { }
            column(lblFreeText2; Trl('FreeText2')) { }
            column(lblFreeText3; Trl('FreeText3')) { }
            column(lblFreeText4; Trl('FreeText4')) { }
            column(lblGiroNo; Trl('GiroNo')) { }
            column(lblGLAccountNo; Trl('GLAccountNo')) { }
            column(lblHeaderDimensions; Trl('HeaderDimensions')) { }
            column(lblHomePage; Trl('HomePage')) { }
            column(lblIBAN; Trl('IBAN')) { }
            column(lblLineDimensions; Trl('LineDimensions')) { }
            column(lblLotNo; Trl('LotNo')) { }
            column(lblNo; Trl('No')) { }
            column(lblPageOf; Trl('Page{0}of{1}')) { }
            column(lblPhoneNo; Trl('PhoneNo')) { }
            column(lblPayToAddress; Trl('PayToVendorAddress')) { }
            column(lblPayToVendorNo; Trl('PayToVendorNo')) { }
            column(lblPostingDate; Trl('PostingDate')) { }
            column(lblPurchPerson; Trl('PurchPerson')) { }
            column(lblQuantity; Trl('Quantity')) { }
            column(lblReturnOrderNo; Trl('ReturnOrderNo')) { }
            column(lblReturnShipmentNo; Trl('ReturnShipmentNo')) { }
            column(lblShipment; Trl('Shipment')) { }
            column(lblSerialNo; Trl('SerialNo')) { }
            column(lblShipmentDate; Trl('ShipmentDate')) { }
            column(lblShipmentMethod; Trl('ShipmentMethod')) { }
            column(lblShipToAddress; Trl('ShipToAddress')) { }
            column(lblSubtotal; Trl('Subtotal')) { }
            column(lblSWIFT; Trl('SWIFT')) { }
            column(lblTotal; Trl('Total')) { }
            column(lblTotalTransFooter; Trl('TotalTransFooter')) { }
            column(lblTotalTransHeader; Trl('TotalTransHeader')) { }
            column(lblUOM; Trl('UOM')) { }
            column(lblVATRegistrationNo; Trl('VATRegistrationNo')) { }
            column(lblYourReference; Trl('YourReference')) { }

            column(CompanyAddr1; wgCompanyAddr[1]) { }
            column(CompanyAddr2; wgCompanyAddr[2]) { }
            column(CompanyAddr3; wgCompanyAddr[3]) { }
            column(CompanyAddr4; wgCompanyAddr[4]) { }
            column(CompanyAddr5; wgCompanyAddr[5]) { }
            column(CompanyAddr6; wgCompanyAddr[6]) { }
            column(CompanyBankAccNo; wgRecCompanyInfo."Bank Account No.") { }
            column(CompanyBankBranchNo; wgRecCompanyInfo."Bank Branch No.") { }
            column(CompanyBankName; wgRecCompanyInfo."Bank Name") { }
            column(CompanyCity; wgRecCompanyInfo.City) { }
            column(CompanyEMail; wgRecCompanyInfo."E-Mail") { }
            column(CompanyFaxNo; wgRecCompanyInfo."Fax No.") { }
            column(CompanyGiroNo; wgRecCompanyInfo."Giro No.") { }
            column(CompanyHomePage; wgRecCompanyInfo."Home Page") { }
            column(CompanyIBAN; wgRecCompanyInfo.IBAN) { }
            column(CompanyPhoneNo; wgRecCompanyInfo."Phone No.") { }
            column(CompanyPicture; wgRecCompanyInfo.Picture) { }
            column(CompanyRegistrationNo; wgRecCompanyInfo."Registration No.") { }
            column(CompanySWIFT; wgRecCompanyInfo."SWIFT Code") { }
            column(CompanyVATRegNo; wgRecCompanyInfo."VAT Registration No.") { }
            column(DocumentDate; "Document Date") { }
            column(DocumentDateText; Format("Document Date", 0, 4)) { }
            column(DocumentNo; "No.") { }
            column(DueDate; "Due Date") { }
            column(DueDateText; Format("Due Date", 0, 4)) { }
            column(LanguageCode; "Language Code") { }
            column(PayToAddr1; wgPayToVendAddr[1]) { }
            column(PayToAddr2; wgPayToVendAddr[2]) { }
            column(PayToAddr3; wgPayToVendAddr[3]) { }
            column(PayToAddr4; wgPayToVendAddr[4]) { }
            column(PayToAddr5; wgPayToVendAddr[5]) { }
            column(PayToAddr6; wgPayToVendAddr[6]) { }
            column(PayToAddr7; wgPayToVendAddr[7]) { }
            column(PayToAddr8; wgPayToVendAddr[8]) { }
            column(PayToVendorNo; "Pay-to Vendor No.") { }
            column(PostingDate; "Posting Date") { }
            column(PostingDateText; Format("Posting Date", 0, 4)) { }
            column(SalesPurchPersonName; wgRecSalesPurchPerson.Name) { }
            column(ShipmentMethodDesc; wgRecShipmentMethod.Description) { }
            column(ShipToAddr1; wgShipToAddr[1]) { }
            column(ShipToAddr2; wgShipToAddr[2]) { }
            column(ShipToAddr3; wgShipToAddr[3]) { }
            column(ShipToAddr4; wgShipToAddr[4]) { }
            column(ShipToAddr5; wgShipToAddr[5]) { }
            column(ShipToAddr6; wgShipToAddr[6]) { }
            column(ShipToAddr7; wgShipToAddr[7]) { }
            column(ShipToAddr8; wgShipToAddr[8]) { }
            column(ShowCorrectionLines; wgShowCorrectionLines) { }
            column(ShowInternalInfo; wgShowInternalInfo) { }
            column(ShowLotSN; wgShowLotSN) { }
            column(TodayText; Format(Today(), 0, 4)) { }
            column(VATRegNo; "VAT Registration No.") { }
            column(YourReference; "Your Reference") { }

            dataitem(CopyLoop; "Integer")
            {
                DataItemTableView = sorting(Number);

                column(OutputNo; wgOutputNo) { }
                column(PurchReturnShipmentTitle; StrSubstNo(Trl('PurchReturnShipment%1'), wgCopyText)) { }

                dataitem(HdrComment; "Purch. Comment Line")
                {
                    DataItemLink = "No." = Field("No.");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Return Shipment"), "Document Line No." = const(0));

                    column(Comment; Comment) { }

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(HeaderDim; "Dimension Set Entry")
                {
                    DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                    column(DimText; wgDimText) { }

                    trigger OnAfterGetRecord()
                    begin
                        wgCduwDCR_ReportFunctions.wgFncGetDimText(HeaderDim, wgDimText);
                    end;

                    trigger OnPreDataItem()
                    begin
                        if not wgShowInternalInfo then
                            CurrReport.Break();
                    end;
                }
                dataitem(ShptLine; "Return Shipment Line")
                {
                    DataItemLink = "Document No." = Field("No.");
                    DataItemLinkReference = ShptHdr;
                    DataItemTableView = sorting("Document No.", "Line No.");

                    column(Description; Description) { }
                    column(LineNo; "Line No.") { }
                    column(No_2; "No.") { }
                    column(Quantity; Quantity) { }
                    column(Type; Format(Type)) { }
                    column(TypeNo; Type + 0) { }
                    column(UOM; wgCduwDCR_TranslationMgt.wgFncGetUnitOfMeaseTrl("Unit of Measure Code")) { }

                    dataitem(LineComment; "Purch. Comment Line")
                    {
                        DataItemLink = "No." = Field("Document No."), "Document Line No." = Field("Line No.");
                        DataItemTableView = sorting("Document Type", "No.", "Document Line No.", "Line No.") where("Document Type" = const("Posted Return Shipment"));

                        column(Comment_2; Comment) { }

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(LineDim; "Dimension Set Entry")
                    {
                        DataItemLink = "Dimension Set ID" = Field("Dimension Set ID");
                        DataItemTableView = sorting("Dimension Set ID", "Dimension Code");

                        column(DimText_2; wgDimText) { }

                        trigger OnAfterGetRecord()
                        begin
                            wgCduwDCR_ReportFunctions.wgFncGetDimText(LineDim, wgDimText);
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowInternalInfo then
                                CurrReport.Break();
                        end;
                    }
                    dataitem(TrackingSpec; "Tracking Specification")
                    {
                        DataItemTableView = sorting("Entry No.");
                        UseTemporary = true;

                        column(LotNo; "Lot No.") { }
                        column(SerialNo; "Serial No.") { }
                        column(Quantity_4; "Quantity (Base)") { }

                        trigger OnAfterGetRecord()
                        begin
                            wgTotalTrackingQty += TrackingSpec."Quantity (Base)";
                        end;

                        trigger OnPreDataItem()
                        begin
                            if not wgShowLotSN then
                                CurrReport.Break();

                            Reset();
                            SetRange("Source Ref. No.", ShptLine."Line No.");
                            wgTotalTrackingQty := 0;
                        end;
                    }

                    trigger OnAfterGetRecord()
                    begin
                        if not wgShowCorrectionLines and Correction then
                            CurrReport.Skip();
                    end;

                    trigger OnPreDataItem()
                    var
                        wlMoreLines: Boolean;
                    begin
                        wlMoreLines := ShptLine.Find('+');
                        while wlMoreLines and (Description = '') and ("No." = '') and (Quantity = 0) do
                            wlMoreLines := Next(-1) <> 0;
                        if not wlMoreLines then
                            CurrReport.Break();
                        SetRange("Line No.", 0, "Line No.");
                    end;
                }
                dataitem(Total; "Integer")
                {
                    DataItemTableView = sorting(Number) where(Number = const(1));

                    column(TotalTrackingQty; wgTotalTrackingQty) { }
                }

                trigger OnAfterGetRecord()
                begin
                    if Number > 1 then begin
                        wgCopyText := CopyStr(Trl('Copy'), 1, 30);
                        wgOutputNo += 1;
                    end;
                end;

                trigger OnPostDataItem()
                begin
                    if not CurrReport.Preview() then
                        wgCduRcptCountPrinted.Run(ShptHdr);
                end;

                trigger OnPreDataItem()
                begin
                    wgNoOfLoops := Abs(wgNoOfCopies) + 1;
                    wgCopyText := '';
                    SetRange(Number, 1, wgNoOfLoops);
                    wgOutputNo := 1;
                end;
            }

            trigger OnAfterGetRecord()
            begin
                CurrReport.Language := wgCduLanguage.GetLanguageIdOrDefault("Language Code");
                wgCduwDCR_TranslationMgt.wgFncSetLanguageCode("Language Code");

                wlFncFormatDocumentFields(ShptHdr);
                wlFncFormatAddressFields(ShptHdr);

                if wgLogInteraction then
                    if not CurrReport.Preview() then
                        wgCduSegManagement.LogDocument(
                          21, "No.", 0, 0, Database::Vendor, "Buy-from Vendor No.", "Purchaser Code", '', "Posting Description", '');

                // Get Item Tracking
                TrackingSpec.Reset();
                TrackingSpec.DeleteAll();
                if wgShowLotSN then begin
                    wgCduItemTrackingDocMgt.SetRetrieveAsmItemTracking(false);
                    wgCduItemTrackingDocMgt.RetrieveDocumentItemTracking(TrackingSpec, ShptHdr."No.",
                        Database::"Return Shipment Header", 0);
                end;
            end;
        }
    }

    requestpage
    {
        SaveValues = true;

        layout
        {
            area(content)
            {
                group(Options)
                {
                    Caption = 'Options';
                    field(NoOfCopies; wgNoOfCopies)
                    {
                        ApplicationArea = All;
                        Caption = 'No. of Copies';
                    }
                    field(ShowInternalInfo; wgShowInternalInfo)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Internal Information';
                    }
                    field(ShowLotSN; wgShowLotSN)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Serial/Lot Number';
                        Visible = false;
                    }
                    field(LogInteraction; wgLogInteraction)
                    {
                        ApplicationArea = All;
                        Caption = 'Log Interaction';
                        Enabled = wgLogInteractionEnable;
                    }
                    field("Show Correction Lines"; wgShowCorrectionLines)
                    {
                        ApplicationArea = All;
                        Caption = 'Show Correction Lines';
                    }
                }
            }
        }

        trigger OnInit()
        begin
            wgLogInteractionEnable := true;
        end;

        trigger OnOpenPage()
        begin
            wgLogInteraction := wgCduSegManagement.FindInteractTmplCode(21) <> '';
            wgLogInteractionEnable := wgLogInteraction;

            wgNoOfCopies := 0;
        end;
    }

    trigger OnInitReport()
    begin
        wgRecSalesSetup.Get();

        wgRecCompanyInfo.Get();

        if wgRecSalesSetup."Logo Position on Documents" <> wgRecSalesSetup."Logo Position on Documents"::"No Logo" then
            wgRecCompanyInfo.CalcFields(Picture);
    end;

    var
        wgRecCompanyInfo: Record "Company Information";
        wgRecPaymentTerms: Record "Payment Terms";
        wgRecSalesPurchPerson: Record "Salesperson/Purchaser";
        wgRecSalesSetup: Record "Sales & Receivables Setup";
        wgRecShipmentMethod: Record "Shipment Method";
        wgCduFormatAddr: Codeunit "Format Address";
        wgCduFormatDoc: Codeunit "Format Document";
        wgCduItemTrackingDocMgt: Codeunit "Item Tracking Doc. Management";
        wgCduLanguage: Codeunit Language;
        wgCduRcptCountPrinted: Codeunit "Return Shipment - Printed";
        wgCduSegManagement: Codeunit SegManagement;
        wgCduwDCR_ReportFunctions: Codeunit wDCR_ReportFunctions;
        wgCduwDCR_TranslationMgt: Codeunit wDCR_TranslationMgt;
        wgCompanyAddr: array[8] of Text[100];
        wgCompanyInfoFaxNo: Text;
        wgCompanyInfoPhoneNo: Text;
        wgCopyText: Text[30];
        wgDimText: Text[120];
        wgPayToVendAddr: array[8] of Text[100];
        wgShipToAddr: array[8] of Text[100];
        wgTotalTrackingQty: Decimal;
        wgNoOfCopies: Integer;
        wgNoOfLoops: Integer;
        wgOutputNo: Integer;
        wgReportId: Integer;
        wgLogInteraction: Boolean;
        [InDataSet]
        wgLogInteractionEnable: Boolean;
        wgShowCorrectionLines: Boolean;
        wgShowInternalInfo: Boolean;
        wgShowLotSN: Boolean;

    local procedure Trl(pLblName: Text[50]): Text
    begin
        if wgReportId = 0 then begin
            Evaluate(wgReportId, DelChr(CurrReport.ObjectId(false), '=', DelChr(CurrReport.ObjectId(false), '=', '1234567890')));
            wgCduwDCR_TranslationMgt.wgFncSetReportId(wgReportId);
        end;
        exit(wgCduwDCR_TranslationMgt.wgFncTranslate(pLblName));
    end;

    procedure InitializeRequest(pNewNoOfCopies: Integer; pNewShowInternalInfo: Boolean; pNewLogInteraction: Boolean; pNewShowCorrectionLines: Boolean)
    begin
        wgNoOfCopies := pNewNoOfCopies;
        wgShowInternalInfo := pNewShowInternalInfo;
        wgLogInteraction := pNewLogInteraction;
        wgShowCorrectionLines := pNewShowCorrectionLines;
    end;

    local procedure wlFncFormatDocumentFields(pRecSalesShptHeader: Record "Return Shipment Header")
    var
        wlSalesPersonText: Text[50];
    begin
        with pRecSalesShptHeader do begin
            wgCduFormatDoc.SetPurchaser(wgRecSalesPurchPerson, "Purchaser Code", wlSalesPersonText);
            wgCduFormatDoc.SetPaymentTerms(wgRecPaymentTerms, "Payment Terms Code", "Language Code");
            wgCduFormatDoc.SetShipmentMethod(wgRecShipmentMethod, "Shipment Method Code", "Language Code");
        end;
    end;

    local procedure wlFncFormatAddressFields(var vRecSalesShptHeader: Record "Return Shipment Header")
    var
        wlRecRespCenter: Record "Responsibility Center";
    begin
        wgCduFormatAddr.GetCompanyAddr(vRecSalesShptHeader."Responsibility Center", wlRecRespCenter, wgRecCompanyInfo, wgCompanyAddr);
        wgCompanyInfoPhoneNo := wgRecCompanyInfo."Phone No.";
        wgCompanyInfoFaxNo := wgRecCompanyInfo."Fax No.";
        wgCduFormatAddr.PurchShptBuyFrom(wgShipToAddr, vRecSalesShptHeader);
        wgCduFormatAddr.PurchShptPayTo(wgPayToVendAddr, vRecSalesShptHeader);
    end;
}
